/**
  ******************************************************************************
  * @file    vk1072d.c
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   This file contains all the vk1072d functions. 
	*          ļ VK1072d
  ******************************************************************************
  * @attention
  ******************************************************************************
  */	
/* Includes ------------------------------------------------------------------*/
#include "vk1072d.h"
  
/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define VK1072d_CLK 10 //WRźƵ,delay_nusʵ 50->10kHz 10->50kHz 5->100kHz
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//segtab[]ӦʵʵоƬLCDߣ߼-VK1072dο·
unsigned char vk1072d_segtab[VK1072d_SEGNUM]={
	0,1,2,3,4,5,					//SEG0-SEG5
	13,14,15,16,17,18,19,	//SEG13-SEG19
	26,27,28,29,30				//SEG26-SEG30
};
//LCDʵֻSEG13SEG19,SEG26SEG30,ʹ
//.hļVK1072d_SEGNUM=12
//const unsigned char vk1072d_segtab[VK1072d_SEGNUM]={
//	13,14,15,16,17,18,19,	//SEG13-SEG19
//	26,27,28,29,30				//SEG26-SEG30
//};
//vk1072d_dispramӦоƬʾRAM
unsigned char vk1072d_dispram[VK1072d_SEGNUM];
//Ӧvk1072d_segtab[VK1072d_SEGNUM]
//ʾRAM bufferֻʹõ4λbit0->com0,bit1->com1,bit2->com2,bit3->com3
//LCD ʵ  38
//1ǰλ2ʮλ3Ǹλ
/*ʾbufferlcdͼӳϵ
vk1072d_dispram[VK1072d_SEGNUM]=
{//com3   com2   com1     com0 //ӦоƬSEG  ӦʾRAM
	1D,     1E,    1F,      1A,     //seg0   			vk1072d_dispram[0]
	  ,     1C,    1G,      1B,     //seg1				vk1072d_dispram[1]
	2D,     2E,    2F,      2A,     //seg18				vk1072d_dispram[11]	
	  ,     2C,    2G,      2B,     //seg19				vk1072d_dispram[12]
	3D,     3E,    3F,      3A,		  //seg26				vk1072d_dispram[13]
	  ,     3C,    3G,      3B,			//seg27				vk1072d_dispram[14]
}
*/
/*8ֵ 
     A
   F   B
     G
	 E   C
	   D
*/
unsigned char shuzi_zimo[15]= //ַֺģ
{
//0    1    2    3    4    5    6    7    8    9    -    L    o    H    i 
	0xF5,0x05,0xD3,0x97,0x27,0xB6,0xF6,0x15,0xF7,0xB7,0x02,0xE0,0xC6,0x67,0x05
};
unsigned char vk1072d_addrbit=6;//icramַA5-A0,
unsigned char vk1072d_segi,vk1072d_comi;
unsigned char vk1072d_maxcom;//com4com3com2com
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void delay_nms(unsigned long int n)
{
	while(n--)
	{
		delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : WriteClock
* Description    : WRʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteClockVk1072d(void)
{
	VK1072d_WR_L(); 
	delay_nus(VK1072d_CLK);
	VK1072d_WR_H();	
	delay_nus(VK1072d_CLK);	
}
/*******************************************************************************
* Function Name  : WriteCommand
* Description    : д
* Input          : FunctonCode->/ 
* Output         : None
* Return         : None
*******************************************************************************/
void WriteCommandVk1072d(unsigned char FunctonCode)
{
	unsigned char Shift = 0x80; 
	unsigned char i;
	
	VK1072d_CS_L();   //CS Ƭѡ   
	delay_nus(VK1072d_CLK/2);
	VK1072d_DATA_H();  
	WriteClockVk1072d();
	VK1072d_DATA_L();  
	WriteClockVk1072d();
	VK1072d_DATA_L();  
	WriteClockVk1072d();

	for(i = 0; i < 8; i++) 
	{
	 if(Shift & FunctonCode) 	
		 VK1072d_DATA_H(); 
	 else 
		 VK1072d_DATA_L();	  

	 WriteClockVk1072d();
	 Shift = Shift >> 1;
	}
  VK1072d_DATA_L(); 
	WriteClockVk1072d();	//һ0һλ X
  VK1072d_CS_H(); 			//CS Ƭѡ  
	delay_nus(VK1072d_CLK/2);
  VK1072d_DATA_H(); 
}

/*******************************************************************************
* Function Name  : Write1Data
* Description    : д1SEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramĵַ  
* 							 : Databuf->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Write1DataVk1072d(unsigned char Addr,unsigned char Dat)
{
	unsigned char i; 
	unsigned char Shift;
	
	Shift = 0x20; //θ3λ ֻ5λ
	
	VK1072d_CS_L();  //CS Ƭѡ
	delay_nus(VK1072d_CLK/2);

	VK1072d_DATA_H();  
	WriteClockVk1072d();  //101
	VK1072d_DATA_L();  
	WriteClockVk1072d();
	VK1072d_DATA_H();  
	WriteClockVk1072d();

	for( i = 0; i < vk1072d_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1072d_DATA_H(); 		
		else  
			VK1072d_DATA_L();
		WriteClockVk1072d();		
		Shift = Shift >> 1; 
	}
  Shift = 0x01;
  for (i = 0; i < 4; i++) 
	{

		if( Dat & Shift) 
			VK1072d_DATA_H();		 
   	else  
			VK1072d_DATA_L();
		WriteClockVk1072d();
		Shift = Shift << 1;
	}   
  VK1072d_CS_H(); //CS Ƭѡ
	delay_nus(VK1072d_CLK/2);	
  VK1072d_DATA_H(); 
}
/*******************************************************************************
* Function Name  : WritenData
* Description    : дnSEGݵʾRAMbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* Input          : Addr->дramʼַ  
* 							 : Databuf->дramָ(ÿֽݵ4λЧ)  
* 							 : Cnt->дramݸ
* Output         : None
* Return         : None
*******************************************************************************/
void WritenDataVk1072d(unsigned char Addr,unsigned char *Databuf,unsigned char Cnt)
{
	unsigned char i,j; 
	unsigned char Shift;
	unsigned char dataval; 
	
	VK1072d_CS_L();   //CS Ƭѡ 
	delay_nus(VK1072d_CLK/2);

	VK1072d_DATA_H();  
	WriteClockVk1072d();  //101
	VK1072d_DATA_L();  
	WriteClockVk1072d();
	VK1072d_DATA_H();  
	WriteClockVk1072d();

	Shift = 0x20;
	for( i = 0; i < vk1072d_addrbit; i++) 
	{   		 
		if (Addr & Shift) 
			VK1072d_DATA_H(); 		
		else  
			VK1072d_DATA_L();
		WriteClockVk1072d();		
		Shift = Shift >> 1; 
	}
	for (j = 0; j < Cnt; j++) 
	{
		Shift = 0x01;
		dataval=*Databuf++;
		for (i = 0; i < 4; i++) 
		{
			if( dataval & Shift) 
				VK1072d_DATA_H();		 
			else  
				VK1072d_DATA_L();
			WriteClockVk1072d();
			Shift = Shift << 1;
		}   
	}
  VK1072d_CS_H();   //CS Ƭѡ
	delay_nus(VK1072d_CLK/2);	 
  VK1072d_DATA_H(); 
}
/*******************************************************************************
* Function Name  : Vk1072d_DisAll
* Description    : SEGʾͬһݣbit3-COM3 bit2-COM2 bit1-COM1 bit0-COM0
* 					     : 磺0x0fȫ 0x00ȫ 0x05 0x0a 0x03 
* Input          dat->дram(1ֽݵ4λЧ)  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072d_DisAll(unsigned char dat)
{
	unsigned char segi;
	unsigned char dispram[32];
	
	for(segi=0;segi<32;segi++)
	{
		dispram[segi]=0x00;
	}
	for(segi=0;segi<6;segi++)
	{
		dispram[segi]=dat;
	}
	for(segi=13;segi<20;segi++)
	{
		dispram[segi]=dat;
	}
	for(segi=26;segi<31;segi++)
	{
		dispram[segi]=dat;
	}
	WritenDataVk1072d(0,dispram,32);//4bitַԶ1
}
/*******************************************************************************
* Function Name  : DisSegComOn
* Description    : 1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072d_DisSegComOn(unsigned char seg,unsigned char com)
{
		Write1DataVk1072d(seg,(1<<com));
}
/*******************************************************************************
* Function Name  : DisSegComOff
* Description    : ر1(1seg1comӦʾ)
* Input          seg->Ӧseg  
* 		           com->Ӧcom  
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072d_DisSegComOff(unsigned char seg,unsigned char com)
{
		Write1DataVk1072d(seg,~(1<<com));
}
/*******************************************************************************
* Function Name  : Enter_Standby
* Description    : ͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072d_Enter_Standby(void)
{	
	//ʹLCDOFFSYSDIS,ϵͳڵ͹״̬
	//ֻʹƬRCʱԴʱ,ʹϵͳ͹״̬
	WriteCommandVk1072d(OSC_OFF);
	WriteCommandVk1072d(DISP_OFF);
}
/*******************************************************************************
* Function Name  : Exit_Standby
* Description    : ˳͹ģʽ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072d_Exit_Standby(void)
{	
	//˳͹״̬vk1072d
	WriteCommandVk1072d(OSC_ON);
	WriteCommandVk1072d(DISP_ON);
	WriteCommandVk1072d(COM_1_3__4);vk1072d_maxcom=4;	//1/3bias 4com
//	WriteCommandVk1072d(COM_1_3__3);vk1072d_maxcom=3;	//1/3bias 3com
//	WriteCommandVk1072d(COM_1_3__2);vk1072d_maxcom=2;	//1/3bias 2com
//	WriteCommandVk1072d(COM_1_2__4);vk1072d_maxcom=4;	//1/2bias 4com
//	WriteCommandVk1072d(COM_1_2__3);vk1072d_maxcom=3;	//1/2bias 3com
//	WriteCommandVk1072d(COM_1_2__2);vk1072d_maxcom=2;	//1/2bias 2com
}
/*******************************************************************************
* Function Name  : Lowlevel_Init
* Description    : ͨGPIO
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072d_Lowlevel_Init(void)
{
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	GPIO_SetMode(VK1072d_CS_PORT, VK1072d_CS_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1072d_WR_PORT, VK1072d_WR_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1072d_DAT_PORT, VK1072d_DAT_PIN, GPIO_MODE_OUTPUT);	//ֻʾݿΪIO
		
	VK1072d_CS_H();                 
	VK1072d_WR_H();  
	VK1072d_DATA_H(); 	
}
/*******************************************************************************
* Function Name  : Init
* Description    : ʼ
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072d_Init(void)
{	
	//ܽøݿͻƬӦ޸
	Vk1072d_Lowlevel_Init();
	//
	WriteCommandVk1072d(OSC_ON);
	WriteCommandVk1072d(DISP_ON);
	WriteCommandVk1072d(COM_1_3__4);vk1072d_maxcom=4;	//1/3bias 4com
//	WriteCommandVk1072d(COM_1_3__3);vk1072d_maxcom=3;	//1/3bias 3com com2/com1/com0
//	WriteCommandVk1072d(COM_1_3__2);vk1072d_maxcom=2;	//1/3bias 2com com1/com0
//	WriteCommandVk1072d(COM_1_2__4);vk1072d_maxcom=4;	//1/2bias 4com
//	WriteCommandVk1072d(COM_1_2__3);vk1072d_maxcom=3;	//1/2bias 3com com2/com1/com0
//	WriteCommandVk1072d(COM_1_2__2);vk1072d_maxcom=2;	//1/2bias 2com com1/com0
	//ϵĬ(δùܹرս͹)
//	WriteCommandVk1072d(BUZZ_2KHZ);
//	WriteCommandVk1072d(BUZZ_4KHZ);
//	WriteCommandVk1072d(BUZZ_ON);
	WriteCommandVk1072d(BUZZ_OFF);
	WriteCommandVk1072d(IRQ_DIS);
	WriteCommandVk1072d(TIMER_DIS);
	WriteCommandVk1072d(WDT_DIS);
}
/*******************************************************************************
* Function Name  : disp_3num
* Description    : ʾ3λ
* Input          dat->3λ ʮ 
* Output         : None
* Return         : None
*******************************************************************************/
void disp_3num(unsigned int dat)
{		
	unsigned dat8;
	
	dat8=dat/100%10;	//ʾλ
	vk1072d_dispram[0]=shuzi_zimo[dat8]>>4;
	vk1072d_dispram[1]&=0xf8;
	vk1072d_dispram[1]|=shuzi_zimo[dat8]&0x07;
	
	dat8=dat/10%10; 	//ʾʮλ
	vk1072d_dispram[11]=shuzi_zimo[dat8]>>4;
	vk1072d_dispram[12]&=0xf8;
	vk1072d_dispram[12]|=shuzi_zimo[dat8]&0x07;
	
	dat8=dat%10;			//ʾλ
	vk1072d_dispram[13]=shuzi_zimo[dat8]>>4;
	vk1072d_dispram[14]&=0xf8;
	vk1072d_dispram[14]|=shuzi_zimo[dat8]&0x07;
		
	if(dat<100)				//С100λʾ
	{
		vk1072d_dispram[0]&=0xf0;
		vk1072d_dispram[1]&=0xf8;
	}
	if(dat<10) 	//С10ʮλʾ
	{
		vk1072d_dispram[11]&=0xf0;
		vk1072d_dispram[12]&=0xf8;
	}
	//SEG11
//	Write1DataVk1072d(8,vk1072d_dispram[0]);
//	Write1DataVk1072d(9,vk1072d_dispram[1]);
//	Write1DataVk1072d(20,vk1072d_dispram[11]);
//	Write1DataVk1072d(21,vk1072d_dispram[12]);
//	Write1DataVk1072d(22,vk1072d_dispram[13]);
//	Write1DataVk1072d(23,vk1072d_dispram[14]);
	//SEGͶ
	WritenDataVk1072d(0,&vk1072d_dispram[0],2);
	WritenDataVk1072d(18,&vk1072d_dispram[11],2);
	WritenDataVk1072d(26,&vk1072d_dispram[13],2);
}	
/*******************************************************************************
* Function Name  : test_Main
* Description    : 
* Input          None 
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1072d_Main(void)
{	
	Vk1072d_Init();
	Vk1072d_DisAll(0x00);
	while(1)
	{
		Vk1072d_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1072d_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		disp_3num(123);           //ʾ123
		delay_nms(3000);					//ʱ3S
		
		Vk1072d_DisAll(0x00);			//LCDȫ
		for(vk1072d_segi=0;vk1072d_segi<VK1072d_SEGNUM;vk1072d_segi++)//seg
		{
			for(vk1072d_comi=0;vk1072d_comi<vk1072d_maxcom;vk1072d_comi++)//com
			{
				Vk1072d_DisSegComOn(vk1072d_segtab[vk1072d_segi],vk1072d_comi);	//LCD
				delay_nms(300);				//ʱ300mS
				Vk1072d_DisAll(0x00);	//LCDȫ
			}
		}
		
		Vk1072d_DisAll(0x0f);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		for(vk1072d_segi=0;vk1072d_segi<VK1072d_SEGNUM;vk1072d_segi++)//seg
		{
			for(vk1072d_comi=0;vk1072d_comi<vk1072d_maxcom;vk1072d_comi++)//com
			{
				Vk1072d_DisSegComOff(vk1072d_segtab[vk1072d_segi],vk1072d_comi);	//LCDر
				delay_nms(300);				//ʱ300mS
				Vk1072d_DisAll(0x0f);	//LCDȫ
			}
		}
		delay_nms(1000);					//ʱ1S
		
		Vk1072d_DisAll(0x00);			//LCDȫ
		delay_nms(1000);					//ʱ1S
		
		Vk1072d_Enter_Standby();		//͹ģʽ
		delay_nms(5000);					//ʱ5S
		
		Vk1072d_Exit_Standby();		//˳͹ģʽ
	}
}
/************************END OF FILE****/
